unit fitsdemo1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Menus,
  Imgwin,Gmlib,Abitmap,astro1,curve1,inifiles, Buttons{,Math};

const
  Inifilename='fitsmag1.ini';

type

  TMainform = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Load1: TMenuItem;
    Setup1: TMenuItem;
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    OpenDialog1: TOpenDialog;
    Upperscrollbar: TScrollBar;
    LowerScrollBar: TScrollBar;
    LblLower: TLabel;
    LblUpper: TLabel;
    Flipcheck: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ROImenu: TMenuItem;
    MROIneu: TMenuItem;
    MROIedit: TMenuItem;
    Timer1: TTimer;
    Analyse1: TMenuItem;
    SaveDialog1: TSaveDialog;
    mROIreset: TMenuItem;
    Serieladen1: TMenuItem;
    BlinkTimer: TTimer;
    BlinkBox: TCheckBox;
    Help1: TMenuItem;
    Info1: TMenuItem;
    Infotimer: TTimer;
    BlinkScrollBar: TScrollBar;
    EditSeries: TMenuItem;
    Loadbutton: TSpeedButton;
    Label4: TLabel;
    Editbutton: TSpeedButton;
    ROIbutton: TSpeedButton;
    testButton1: TButton;
    Window1: TMenuItem;
    Tile1: TMenuItem;
    ClearROIs1: TMenuItem;
    SaveROIs1: TMenuItem;
    LoadROIs1: TMenuItem;
    Processing1: TMenuItem;
    Backgroundsubtraction1: TMenuItem;
    Saveimage1: TMenuItem;
    SaveFitsDialog: TSaveDialog;
    EliminateLines: TMenuItem;
    test11: TMenuItem;
    setDCFmarker1: TMenuItem;
    getDCFtime1: TMenuItem;
    Label5: TLabel;
    procedure Exit1Click(Sender: TObject);
    procedure Getlevels(var image:Timgbuffer; var l1,l2:integer);
    procedure Load1Click(Sender: TObject);
    procedure LowerScrollBarChange(Sender: TObject);
    procedure UpperscrollbarChange(Sender: TObject);
    procedure MROIneuClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MROIeditClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Analyse1Click(Sender: TObject);
    procedure mROIresetClick(Sender: TObject);
    procedure Serieladen1Click(Sender: TObject);
    procedure Display(filename:string);
    procedure BlinkTimerTimer(Sender: TObject);
    procedure BlinkBoxClick(Sender: TObject);
    procedure Info1Click(Sender: TObject);
    procedure InfotimerTimer(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure BlinkScrollBarChange(Sender: TObject);
    procedure EditSeriesClick(Sender: TObject);
    procedure FlipcheckClick(Sender: TObject);
    procedure testButton1Click(Sender: TObject);
    procedure Tile1Click(Sender: TObject);
    procedure ClearROIs1Click(Sender: TObject);
    procedure SaveROIs1Click(Sender: TObject);
    procedure LoadROIs1Click(Sender: TObject);
    procedure Backgroundsubtraction1Click(Sender: TObject);
    procedure Saveimage1Click(Sender: TObject);
    procedure EliminateLinesClick(Sender: TObject);
    procedure test11Click(Sender: TObject);
    procedure setDCFmarker1Click(Sender: TObject);
    procedure getDCFtime1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TConfigOptions = class(TObject)
    IniFile         : Tinifile;
    StartupDir      : string;
  public
    constructor create;
    function ReadOptions:boolean;
    function WriteOptions:boolean;
    procedure SetDefaultOptions;
  private
  end;

var
  ConfigOptions: TConfigOptions;
  Progdir: string;
  Mainform: TMainform;
  ImgWin1: Timgform1;
  ImgWin2: Timgform1;
  ImgTrack: Timgform1;
  img: Timgbuffer;
  lowerlevel,upperlevel: single;
  NewROI: boolean;
  BGROI: integer;
  DCFROI: boolean;
  EditROI: boolean;
  imageLoaded: boolean;
  imagepath: string;
  filelist1: Tstringlist;
  FramesLoaded: integer;
  Activeframe: integer;
  XTimes: TimeArray;
  YMags: MagArray;

implementation

uses Roi1, InfoUnit, Fileedit;


{$R *.DFM}
  procedure TConfigOptions.SetDefaultOptions;
  begin
    StartupDir:='';
  end;

  constructor TConfigOptions.Create;
  begin
    inherited create;
    SetDefaultOptions;
  end;

  function TConfigOptions.ReadOptions:boolean;
  begin
    If (Inifile=nil) then Inifile:=Tinifile.create(inifilename);
    StartupDir:=Inifile.ReadString('File','StartupDir',StartupDir);
    ReadOptions:=true;
  end;

  function TConfigOptions.WriteOptions:boolean;
  begin
    WriteOptions:=false;
    If (Inifile=nil) then Inifile:=Tinifile.create(Inifilename);
    Inifile.WriteString('File','StartupDir',StartupDir);
    WriteOptions:=true;
  end;

procedure TMainform.Exit1Click(Sender: TObject);
begin
  Close;
end;


procedure Tmainform.Getlevels(var image:Timgbuffer; var l1,l2:integer);
begin
    LowerLevel:= sqr(Lowerscrollbar.position/100);
    UpperLevel:= sqr(Upperscrollbar.position/100);
    l1:= {image.buffermin+}round(Lowerlevel*(image.buffermax{-image.buffermin}));
    l2:= {image.buffermin+}round(Upperlevel*(image.buffermax{-image.buffermin}));
    LblLower.caption:=INttoStr(l1);
    Lblupper.caption:=Inttostr(l2);
end;

procedure TMainform.Load1Click(Sender: TObject);
var
  l1,l2: integer;
begin
  if img=nil then
  begin
    img.free;
    img:=Timgbuffer.create;
  end;
  if opendialog1.execute then
  begin
    if ExtractFileExt(opendialog1.FileName)='.bmp' then
    begin
      if (not img.ReadBMPfile(opendialog1.FileName)) then
      begin
        ShowMessage('Error reading BMP file');
        exit;
      end;
    end else if (not img.readfitsfile(opendialog1.filename)) then
    begin
      ShowMessage('Error reading FITS file');
      exit;
    end;
    ImagePath:=justPathname(opendialog1.filename);
    opendialog1.initialdir:=ImagePath;
    if Flipcheck.checked then img.flipvertical;
    Imgwin1.free;
    Imgwin1:=TImgform1.create(application);
    Imgwin1.paintbox1.width:=img.xsize;
    Imgwin1.paintbox1.height:=img.ysize;
    Getlevels(img,l1,l2);
    Imgwin1.ShowImage(img, l1,l2);
    ImageLoaded:=true;
    If ROIindex>0 then ROIform1.ROIchanged:=true;
 end;
end;

procedure TMainform.LowerScrollBarChange(Sender: TObject);
var
  l1,l2:integer;
begin
  Getlevels(img,l1,l2);
  Imgwin1.ShowImage(img, l1,l2);
end;

procedure TMainform.UpperscrollbarChange(Sender: TObject);
var
  l1,l2:integer;
begin
  Getlevels(img,l1,l2);
  Imgwin1.ShowImage(img, l1,l2);
end;

procedure TMainform.MROIneuClick(Sender: TObject);
begin
  If not ImageLoaded then
  begin
    ShowMessage('Load image first'); exit;
  end;
  if ROIform1=nil then
  begin
    application.createform(TRoiform1,ROIform1);
  end;
  ROIform1.visible:=true; ROIform1.WindowState:=wsnormal;
  NewROI:=true;
  Statusbar1.SimpleText:='Stern mit linker Maustaste markieren';
end;

procedure TMainform.FormCreate(Sender: TObject);
begin
  Progdir:=addbackslash(Extractfiledir(Application.exename));
  ConfigOptions:=TconfigOptions.create;
  ConfigOptions.ReadOptions;
  OpenDIalog1.InitialDir:=ConfigOptions.StartupDir;
  NewROI:=false; BGROI:=-1;
  EditROI:=false;
  DCFROI:=false;
  ImageLoaded:=false;
  Imagepath:='';
  FramesLoaded:=0;
  FileList1:=Tstringlist.create;
  FileList1.sorted:=true;
  img:=Timgbuffer.create;
  //Application.CreateForm(TInfoform, Infoform);

  //Infoform.visible:=true;
  //Infotimer.enabled:=true;
end;

procedure TMainform.MROIeditClick(Sender: TObject);
begin
  If ROIindex=0 then
  begin
    SHowMessage('Noch keine ROI definiert.'); exit;
  end;
  //showmessage('Noch nicht implementiert');
  EditROI:=true;
  Statusbar1.SimpleText:='ROI mit linker Maustaste verschieben';
end;

procedure TMainform.Timer1Timer(Sender: TObject);
begin
  If ROIform1=nil then exit;
  If ROIform1.ROIchanged then
  begin
     imgwin1.paintbox1.invalidate;
     ROIform1.UpdateROItable;
     ROIform1.ROIchanged:=false;
  end;
end;

procedure TMainform.Display(filename:string);
var
  i,l1,l2,iroi: integer;

begin
    if ExtractFileExt(filename)='.bmp' then
    begin
      if (not img.ReadBMPfile(filename)) then
      begin
        ShowMessage('Error reading BMP file');
        exit;
      end;
    end else if (not img.readfitsfile(filename)) then
    begin
      ShowMessage('Error reading FITS file');
      exit;
    end;
    if Flipcheck.checked then img.flipvertical;

    Imgwin1.paintbox1.width:=img.xsize;
    Imgwin1.paintbox1.height:=img.ysize;
    Getlevels(img,l1,l2);
    Imgwin1.ShowImage(img, l1,l2);
    if ROIform1<>nil then ROIform1.UpdateROItable;
    Imgwin1.ShowImage(img, l1,l2);

end;

procedure TMainform.Analyse1Click(Sender: TObject);
var
  filename:string;
  SearchRec:TsearchRec;
  i,l1,l2,iroi: integer;
  ROI: TROI1;
  resultfile: textfile;
  kontrolle: boolean;
  //Filelist:Tstringlist;

begin
  kontrolle:=false;
  If ROIindex=0 then
  begin
    SHowMessage('No ROI defined.');
    exit;
  end;
  if not Savedialog1.execute then exit;
  Assignfile(resultfile,Savedialog1.FileName);
  rewrite(resultfile);
  write(resultfile,'"filename";"JD-2450000";');
  //for i:=1 to ROIlist.count do write(resultfile,'"ROI'+InttoStr(i)+' counts";"  mag";');
  for i:=1 to ROIlist.count do write(resultfile,'"ROI'+InttoStr(i)+'  mag";');
  writeln(resultfile);
  write(resultfile,'"------";','0');
  for iroi:=1 to ROIlist.count do
  begin
      ROI:=ROIlist.items[iroi-1];
      if ROI.ref then write(resultfile,';',FloattoStrF(ROI.rmag,ffFixed,6,3))
                 else write(resultfile,';"?"');
  end;
  writeln(resultfile);
  //findfirst(ImagePath+'*.fit',faAnyFile, SearchRec);
  ROIform1.ResetROIposition;
  {
  FileList:=Tstringlist.create;
  FileList.sorted:=true;
  repeat
    filename:=searchrec.name;
    fileList.add(filename);
  until findnext(SearchRec)<>0;
  findclose(SearchRec);
  }
  for i:=0 to FileList1.count-1 do
  begin
    if ExtractFileExt(FileList1.Strings[i])='.bmp' then
    begin
      if (not img.ReadBMPfile(FileList1.Strings[i])) then
      begin
        ShowMessage('Error reading BMP file');
        exit;
      end;
    end else if (not img.readfitsfile(FileList1.Strings[i])) then
    begin
      ShowMessage('Error reading FITS file');
      exit;
    end;
    if Flipcheck.checked then img.flipvertical;

    Imgwin1.paintbox1.width:=img.xsize;
    Imgwin1.paintbox1.height:=img.ysize;
    Getlevels(img,l1,l2);
    Imgwin1.ShowImage(img, l1,l2);
    ROIform1.UpdateROItable;
    Imgwin1.ShowImage(img, l1,l2);
    ImageLoaded:=true;
    write(resultfile,'"',img.filename,'";',FloattoStrF(img.JDstart-2450000,ffFixed,10,5));
    XTimes[i]:=img.JDstart-2450000;
    for iroi:=1 to ROIlist.count do
    begin
      ROI:=ROIlist.items[iroi-1];
      //write(resultfile,';',InttoStr(ROI.acounts-ROI.bcounts));
      write(resultfile,';',FloattoStrF(ROI.mag,ffFixed,6,3));
      YMags[i,iroi]:=ROI.mag;
    end;
    writeln(resultfile);
    if kontrolle then
    begin
      case MessageDlgPos('next file',mtcustom,[mbOK,mbCancel],0,Imgwin1.Left+Imgwin1.width,Imgwin1.top+Imgwin1.Height) of
      mrCancel: begin
                closefile(resultfile);
                exit;
             end;
      end;
    end;
  end;
    //ShowMessage(filename);
  closefile(resultfile);
  If CurveForm=nil then Application.CreateForm(TCurveForm,CurveForm);
  CurveForm.Visible:=true;
  CurveForm.ShowCurves(Xtimes,Ymags,ROIlist.count,FileList1.count);
end;

procedure TMainform.mROIresetClick(Sender: TObject);
begin
    ROIform1.ResetROIposition;
    Imgwin1.PaintBox1Paint(self);
end;

procedure TMainform.Serieladen1Click(Sender: TObject);
var
  filename:string;
  SearchRec:TsearchRec;
  i: integer;
begin
   OpenDialog1.Options := [ofAllowMultiSelect, ofFileMustExist];
   if opendialog1.execute then
   begin
     ConfigOptions.Startupdir:=ExtractFiledir(Opendialog1.FileName);
     ConfigOptions.WriteOptions;
     if img=nil then
     begin
       img.free;
       img:=Timgbuffer.create;
     end;
     if FileList1<>nil then begin FileList1.free; FileList1:=nil; end;
     FileList1:=Tstringlist.create;
     FileList1.sorted:=true;
     with Opendialog1.files do
     begin
       for i:=0 to Count-1 do FileList1.add(Strings[i]);
       FramesLoaded:=count;
     end;
     Blinkbox.enabled:=true;
     BlinkScrollbar.Max:=FramesLoaded;
     ImagePath:=justPathname(opendialog1.filename);
     opendialog1.initialdir:=ImagePath;
     Imgwin1.free;
     Imgwin1:=TImgform1.create(application);
     Display(filelist1.Strings[0]);
     ImageLoaded:=true;
  end else exit;
end;

procedure TMainform.BlinkTimerTimer(Sender: TObject);

begin
  If ((not Blinkmode) or ErrorReporting) then
  begin
    Blinkmode:=false;
    Blinkbox.checked:=false;
    Blinktimer.enabled:=false;
    exit;
  end;
  If ((FramesLoaded>0) and blinkmode) then
  begin
    Inc(ActiveFrame);
    if ActiveFrame>FramesLoaded then ActiveFrame:=1;
    BlinkScrollbar.Position:=ActiveFrame;
    //Display(filelist1.Strings[ActiveFrame-1]);
  end;
end;

procedure TMainform.BlinkBoxClick(Sender: TObject);
begin
  if Blinkbox.checked then
  begin
    Blinktimer.enabled:=true;
    Blinkmode:=true;
  end else
  begin
    Blinktimer.enabled:=false;
    Blinkmode:=false;
  end;

end;

procedure TMainform.Info1Click(Sender: TObject);
begin
  Infoform.visible:=true;
end;

procedure TMainform.InfotimerTimer(Sender: TObject);
begin
  Infoform.Visible:=false;
  Infotimer.enabled:=false;
end;

procedure TMainform.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  //Infoform.close;
  CanClose:=true;
end;

procedure TMainform.BlinkScrollBarChange(Sender: TObject);
begin
  if FramesLoaded>0 then
  begin
    ActiveFrame:=BlinkScrollbar.Position;
    Display(filelist1.Strings[ActiveFrame-1]);
  end;
end;

procedure TMainform.EditSeriesClick(Sender: TObject);
var
  i: integer;
begin
  (*
  If ((FileList1=nil) or (FileList1.count=0)) then
  begin
    ShowMessage('No files selected, load series first');
    exit;
  end;
  *)
  FileListForm.FileListEdit.Clear;
  For i:=0 to FileList1.count-1 do
  begin
    FileListForm.FileListEdit.lines.add(FileList1.strings[i]);
  end;
  FileListForm.showModal;
  if FileListForm.ModalResult=mrOK then
  begin
    FileList1.Clear;
    For i:=0 to FileListForm.FileListEdit.lines.count-1 do
      begin
        if FileListForm.FileListEdit.lines[i]<>'' then
           FileList1.Add(FileListForm.FileListEdit.lines[i]);
      end;
    FramesLoaded:=FileList1.Count;
    BlinkScrollbar.Max:=FramesLoaded;
    if Blinkscrollbar.Position>FramesLoaded then Blinkscrollbar.Position:=FramesLoaded;
  end;
end;

procedure TMainform.FlipcheckClick(Sender: TObject);
begin
  if FramesLoaded>0 then
  begin
    ActiveFrame:=BlinkScrollbar.Position;
    Display(filelist1.Strings[ActiveFrame-1]);
  end;

end;

procedure TMainform.testButton1Click(Sender: TObject);
begin
  Imgwin1.free;
  img.free;
end;

procedure TMainform.Tile1Click(Sender: TObject);
begin
  tile;
end;

procedure TMainform.ClearROIs1Click(Sender: TObject);
begin
  ROIform1.ClearROIs;
  Imgwin1.PaintBox1Paint(self);
end;

procedure TMainform.SaveROIs1Click(Sender: TObject);
begin
  ROIform1.SaveROI;
end;

procedure TMainform.LoadROIs1Click(Sender: TObject);
begin
  If not ImageLoaded then
  begin
    ShowMessage('Load image first'); exit;
  end;
  if ROIform1=nil then
  begin
    application.createform(TRoiform1,ROIform1);
  end;
  ROIform1.visible:=true; ROIform1.WindowState:=wsnormal;
  ROIform1.LoadROI;
end;

procedure TMainform.Backgroundsubtraction1Click(Sender: TObject);
var
  i,l1,l2,iroi,n,x,y: integer;
  b,b0: longint;
  Sm,Sxm,Sym,Sx,Sy,Sxx,Sxy,Syy: double;
  a,bx,by,Det:single;
  ROI: TROI1;
begin
  If not ImageLoaded then
  begin
    ShowMessage('No image loaded'); exit;
  end;
  If ROIindex=0 then
  begin
    SHowMessage('No background points defined.');
    exit;
  end;
     n:=0; Sm:=0; Sxm:=0; Sx:=0; Sy:=0; Sym:=0;
     Sxx:=0;Syy:=0; Sxy:=0;
     for iroi:=1 to ROIlist.count do
     begin
          ROI:=ROIlist.items[iroi-1];
          b:=round(ROI.bcounts/(ROI.d*ROI.d));
          x:=ROI.xb; y:=ROI.yb;
          Sm:=Sm+b; Sxm:=Sxm+1.0*x*b; Sym:=Sym+1.0*y*b;
          Sx:=Sx+x; Sy:=Sy+y;
          Sxx:=Sxx+1.0*x*x; Syy:=Syy+1.0*y*y; Sxy:=Sxy+1.0*x*y;
          inc(n);
     end;
     if n<4 then begin
       ShowMessage('zu wenig Messpunkte');
       exit;
     end;
     //Determinante:
     Det:=-n*syy*sxx+sy*sy*sxx+n*sxy*sxy-2*sxy*sy*sx+syy*sx*sx;
     bx:=0; by:=0;
     If Det<>0 then
     begin
       a:=(sx*syy*Sxm-sx*sxy*Sym-sy*sxy*sxm+sy*Sym*sxx-Sm*syy*sxx
           +Sm*sxy*sxy)/Det;

       bx:=-( -n*sxy*Sym +n*Sxm*Syy -Syy*Sx*Sm -Sxm*Sy*Sy +Sxy*Sy*Sm
              +Sx*Sy*Sym)/Det;
       by:=(-Sy*Sx*Sxm +Sy*Sm*Sxx +n*Sxy*Sxm +Sx*Sx*Sym -Sx*Sxy*Sm
               -n*Sym*Sxx)/Det;
     end;
     for x:=1 to img.xsize do
     for y:=1 to img.ysize do
     begin
       i:=max(0,img.getpixel(x,y)+100-round(a+bx*x+by*y));
       img.putpixel(x,y,i);
     end;
     Lowerscrollbar.position:=0;   Getlevels(img,l1,l2);
    Imgwin1.ShowImage(img, l1,l2);

end;

procedure TMainform.Saveimage1Click(Sender: TObject);
begin
  If not ImageLoaded then
  begin
    ShowMessage('No image loaded'); exit;
  end else
  begin
    if SaveFitsdialog.execute then
    begin
      Screen.cursor:=crHourglass;
      if Flipcheck.checked then img.flipvertical;
      img.Writefitsfile(SaveFitsdialog.filename);
      if Flipcheck.checked then img.flipvertical;
      Screen.cursor:=crDefault;
    end;
  end;
end;

procedure TMainform.EliminateLinesClick(Sender: TObject);
var
  i,l1,l2,iroi,n,x,y: integer;
  b,b0,m: longint;
  Sm,Sxm,Sym,Sx,Sy,Sxx,Sxy,Syy: double;
  a,bx,by,Det:single;
  ROI: TROI1;
  SD,TH: single;
  UY: array[1..2048] of longint;
begin
  If not ImageLoaded then
  begin
    ShowMessage('No image loaded'); exit;
  end;
  If ROIindex=0 then
  begin
    SHowMessage('No background points defined.');
    exit;
  end;
     n:=0; Sm:=0; Sxm:=0; Sx:=0; Sy:=0; Sym:=0; a:=0;
     Sxx:=0;Syy:=0; Sxy:=0;
     for iroi:=1 to ROIlist.count do
     begin
          ROI:=ROIlist.items[iroi-1];
          b:=round(ROI.bcounts/(ROI.d*ROI.d));
          x:=ROI.xb; y:=ROI.yb;
          Sm:=Sm+b; Sxm:=Sxm+1.0*x*b; Sym:=Sym+1.0*y*b;
          Sx:=Sx+x; Sy:=Sy+y;
          Sxx:=Sxx+1.0*x*x; Syy:=Syy+1.0*y*y; Sxy:=Sxy+1.0*x*y;
          inc(n);
     end;
     if n<4 then begin
       ShowMessage('zu wenig Messpunkte');
       exit;
     end;
     //Determinante:
     Det:=-n*syy*sxx+sy*sy*sxx+n*sxy*sxy-2*sxy*sy*sx+syy*sx*sx;
     bx:=0; by:=0;
     If Det<>0 then
     begin
       a:=(sx*syy*Sxm-sx*sxy*Sym-sy*sxy*sxm+sy*Sym*sxx-Sm*syy*sxx
           +Sm*sxy*sxy)/Det;

       bx:=-( -n*sxy*Sym +n*Sxm*Syy -Syy*Sx*Sm -Sxm*Sy*Sy +Sxy*Sy*Sm
              +Sx*Sy*Sym)/Det;
       by:=(-Sy*Sx*Sxm +Sy*Sm*Sxx +n*Sxy*Sxm +Sx*Sx*Sym -Sx*Sxy*Sm
               -n*Sym*Sxx)/Det;
     end;
     for x:=1 to img.xsize do
     for y:=1 to img.ysize do
     begin
       i:=max(0,img.getpixel(x,y)+100-round(a+bx*x+by*y));
       img.putpixel(x,y,i);
     end;
     SD:=Sqrt(a/1.51 +225);
     TH:=100+2*SD;
     for y:=1 to img.ysize do
     begin
          UY[y]:=0; n:=0;
          for x:=1 to img.xsize do
          begin
               if img.getpixel(x,y)<TH then
               begin UY[y]:=UY[y]+img.getpixel(x,y); inc(n); end;
          end;
          if n>5 then UY[y]:=(UY[y] div n) else UY[y]:=-1; //nicht benutzen
     end;
     m:=0; n:=0;
     for y:=1 to img.ysize do
     begin
       if UY[y]>=0 then begin m:=m+UY[y]; inc(n); end;
     end;
     if n>0 then m:=m div n;
     for y:=1 to img.ysize do
     begin
        for x:=1 to img.xsize do
        begin
          if UY[y]>=0 then
          begin
               i:=max(0,img.getpixel(x,y)-UY[y]+m);
               img.putpixel(x,y,i);
          end;
        end;
     end;
     Lowerscrollbar.position:=0;
     Getlevels(img,l1,l2);
     Imgwin1.ShowImage(img, l1,l2);
     //ShowMessage('2*SD= '+floattostr(2*SD)+'  m= '+inttostr(m));

end;

procedure TMainform.test11Click(Sender: TObject);
//Stern-Extrahierung, Koordinaten werden in Textdatei gespeichert
type
  star=record x,y: integer; m:single; end;

const
  c1=2; // 2c1+1 quadrat. Raster
  mag0=24.0; // willkrl. Mag-kalibrierung
var
  l1,l2,n,n1,x,y,k,j,k0,j0,b,x0,y0,m,thr: integer;
  i: longint;
  mean,mag,maxmag,minmag: single;
  imgtemp: Timgbuffer;
  nsterne,maxstarindex: integer;
  tx1:textfile;
  pstar: ^star;
  starlist:Tlist;
begin
  nsterne:=0;
  If not ImageLoaded then
  begin
    ShowMessage('No image loaded'); exit;
  end;
  imgtemp:=img.duplicate;
  //output textfile
  assignfile(tx1,img.filename+'.stars.txt');
  rewrite(tx1);

  mean:=0; n:=0;
  n1:=(2*c1+1)*(2*c1+1); //Anzahl Pixel im Glttungs-Raster
  //Glttung und Mittelwertbestimmung
  for x:=1+c1 to imgtemp.xsize-c1 do
     for y:=1+c1 to imgtemp.ysize-c1 do
     begin
       with imgtemp do
       begin
         i:=0;
         for k:=-c1 to +c1 do
         for j:=-c1 to +c1 do
         begin
           i:=i+getpixel(x+k,y+j);
         end;
       end;
       i:=i div n1;
       mean:=mean+i;inc(n);
       img.putpixel(x,y,i);
     end;
  mean:=mean/n;

  //Sternpositionen
  thr:=100+round(sqrt(mean)*10); //Schwellwert f. Sternerkennung
  starlist:=Tlist.Create;
  maxmag:=+99.0; minmag:=-99.0;
  for x:=1+c1+1 to imgtemp.xsize-c1-1 do
     for y:=1+c1+1 to imgtemp.ysize-c1-1 do
     begin
       with imgtemp do
       begin
         m:=0;x0:=0;y0:=0;
         //Messquadrat um (x,y)
         for k:=-c1 to +c1 do
         for j:=-c1 to +c1 do
         begin
           i:=getpixel(x+k,y+j);
           if i>m then begin m:=i; x0:=x; y0:=y; k0:=k; j0:=j; end;
         end;
         //b=Umgebungsint. um (x0,y0)
         b:= (getpixel(x0-c1-1,y0)+getpixel(x0+c1+1,y0)
            +getpixel(x0,y0-c1-1)+getpixel(x0,y0+c1+1)) div 4;
         //selektiere (x,y) ,wenn signif. Max im Zentrum des Messquadrats
         if ((x=x0) and (y=y0) and (m-b>thr)
            and (k0=0) and (j0=0) ) then
         begin
           i:=getpixel(x,y)+getpixel(x-1,y)+getpixel(x+1,y)+getpixel(x,y-1)
              +getpixel(x,y+1) -5*b; //
           //if i<1 then ShowMessage('i='+inttostr(i)+' 5*b='+inttostr(5*b));
           if i<1 then i:=1; // kann vorkommen bei Artefakten wegen Subtraktion
           inc(nsterne);
           mag:=-2.5*ln(i)/ln(10)+mag0; //log10(x)=ln(x)/ln(10)
           if mag>maxmag then maxmag:=mag;
           if mag<minmag then
           begin
             minmag:=mag; maxstarindex:=starlist.Count;
           end;
           new(pstar);
           pstar.x:=x; pstar.y:=y; pstar.m:=mag;
           starlist.Add(pstar);
           writeln(tx1,nsterne,',',x,',',y,',',mag:5:2);
         end
         else
         begin
           i:=0;   //kein Stern
         end;
       end;
       img.putpixel(x,y,i);
     end;

  //Sterndarstellung
  for j:=0 to starlist.Count-1 do
  begin
      pstar:=starlist.Items[j];
      i:=1000*round(mag0-pstar.m);
      i:=max(0,i); i:=min(65000,i);
      with img do
      begin
         putpixel(pstar.x,pstar.y,i);
         putpixel(pstar.x-1,pstar.y,i);
         putpixel(pstar.x+1,pstar.y,i);
         putpixel(pstar.x,pstar.y-1,i);
         putpixel(pstar.x,pstar.y+1,i);
      end;
  end;
  Lowerscrollbar.position:=0;   Getlevels(img,l1,l2);
  Imgwin1.ShowImage(img, l1,l2);

  ShowMessage(inttostr(starlist.Count)+' Sterne gefunden, Sternliste in '
              +img.filename+'.stars.txt');

  //free resources
  Imgtemp.Free;
  closefile(tx1);
  for j:=0 to starlist.Count-1 do dispose(starlist.Items[j]);
  starlist.Free;

end;

procedure TMainform.setDCFmarker1Click(Sender: TObject);
begin
  If not ImageLoaded then
  begin
    ShowMessage('Load image first'); exit;
  end;
  if ROIform1=nil then
  begin
    application.createform(TRoiform1,ROIform1);
  end;
  ROIform1.visible:=true; ROIform1.WindowState:=wsnormal;
  DCFROI:=true;
  Statusbar1.SimpleText:='Bild mit DCF Signal auswhlen und Position mit linker Maustaste markieren';
end;

procedure TMainform.getDCFtime1Click(Sender: TObject);
var
  index,i,k,dcfindex,framenum,lastnum,lastcount,lastfcount: integer;
  ROI:TROI1;
  pDCF: ^DCFrec;
  l1,l2: integer;
  resultfile: textfile;
  s1,s2: double;
  n1,n2: integer;
  m1,m2: integer;
  cx,cmin,cmax:integer;
  minstart: integer;
  dcfbit: array[1..9999] of byte;
begin
  if not Savedialog1.execute then exit;
  Assignfile(resultfile,Savedialog1.FileName);
  rewrite(resultfile);
  dcfindex:=-1;
  lastnum:=-1;
  lastcount:=0;
  lastfcount:=0;
  cmin:=999999; cmax:=0;
  s1:=0; s2:=0; n1:=0; n2:=0;
  for index:=1 to ROIlist.Count do
  begin
    ROI:=ROIlist.items[index-1];
    if ROI.x0a=-1 then dcfindex:=index;
  end;
  if dcfindex<0 then
  begin
       ShowMessage('DCF Marker muss erst gesetzt werden!');
       exit;
  end;
  if DCFlist<>nil then
  begin
    for i:=0 to DCFlist.Count-1 do
    begin pDCF:=DCFlist.Items[i]; dispose(pdcf); end;
    DCFlist.Free;
  end;
  DCFlist:=Tlist.Create;
  for i:=0 to FileList1.count-1 do
  begin
    if ExtractFileExt(FileList1.Strings[i])='.bmp' then
    begin
      if (not img.ReadBMPfile(FileList1.Strings[i])) then
      begin
        ShowMessage('Error reading BMP file');
        exit;
      end;
    end else
    begin
        ShowMessage('Error reading file');
        exit;
    end;
    if Flipcheck.checked then img.flipvertical;
    Imgwin1.paintbox1.width:=img.xsize;
    Imgwin1.paintbox1.height:=img.ysize;
    Getlevels(img,l1,l2);
    Imgwin1.ShowImage(img, l1,l2);
    ROIform1.UpdateROItable;
    //Imgwin1.ShowImage(img, l1,l2);
    ImageLoaded:=true;
    framenum:=i+1;
    ROI:=ROIlist.items[dcfindex-1];
    if ROI.mag<2 then
    begin
       if (lastnum>0) and (framenum-lastnum=1) then
       begin
         inc(pdcf.fcount); lastnum:=framenum;
         pdcf.counts:=pdcf.counts+ROI.acounts-ROI.bcounts;
       end else
       begin
         if lastnum>0 then lastnum:=pdcf.fnum; //start frame
         new(pdcf);
         pdcf.fnum:=framenum; pdcf.fcount:=0; pdcf.interval:=0;
         pdcf.counts:=ROI.acounts-ROI.bcounts;
         pdcf.ftime:=0;
         if lastnum>0 then
         begin
              pdcf.interval:=framenum-lastnum;
              if pdcf.counts<cmin then cmin:= pdcf.counts;
              if pdcf.counts>cmax then cmax:= pdcf.counts;
              if pdcf.interval>0 then begin s1:=s1+pdcf.interval; inc(n1); end;
              s2:=s2+pdcf.counts; inc(n2);
         end;
         lastnum:=framenum;
         dcflist.Add(pdcf);
       end;
    end;//if ROI.mag..
  end;//For i..
  m1:=round(s1/n1); m2:=round(s2/n2);
  cx:=(cmin+cmax) div 2;
  minstart:=-1; k:=0;
  for i:=0 to dcflist.count-1 do
  begin
    pdcf:=dcflist.Items[i];
    if pdcf.counts<cx then pdcf.fcount:=0 else pdcf.fcount:=1;
    if pdcf.interval>1.5*m1 then pdcf.fcount:=-1;//Minutenbegin
    if (minstart<0) and (pdcf.fcount<0) then minstart:=i;
    if (minstart>=0) and (pdcf.fcount>=0) then
    begin
         inc(k); dcfbit[k]:=pdcf.fcount;
    end;
    writeln(resultfile,pdcf.fnum,', ',pdcf.fcount,', ',pdcf.counts,', ',pdcf.interval);
  end;
  writeln(resultfile,'mittl. intervall=',m1,' mittl. counts=',m2);
  writeln(resultfile,'Jahr=',dcfbit[50]+2*dcfbit[51]+4*dcfbit[52]+8*dcfbit[53]
                            +10*dcfbit[54]+20*dcfbit[55]+40*dcfbit[56]+80*dcfbit[57]);
  closefile(resultfile);

end;

end.
